import ap.SimpleAPI
import ap.parser._

object Hi {
  def main(args: Array[String]) =
    SimpleAPI.withProver { p =>
      import p._
      import IExpression._

      println("Solving riddle ...")

      /**
       * A simple riddle taken from
       * http://puzzleparasite.blogspot.de/2015/04/2014-slovak-puzzle-championships.html
       */

      // Create integer variables ranging from 1 to 9
      val consts@Seq(h, a, t, e, l, o, v, s, k) =
        List("h", "a", "t", "e", "l",
             "o", "v", "s", "k") map (createConstant(_, 1 to 9))

      !! (distinct(consts))

      !! (h+a+t+e === 20)
      !! (l+o+v+e === 14)
      !! (s+o+l+v+e === 20)
      !! (a+s+k === 14)
      !! (l+e+a+s+t === 20)
      !! (v+e+t === 14)

      println(???)
      println(partialModel)

      println("Checking uniqueness ...")

      !! (or(for (x <- consts) yield (x =/= eval(x))))
      println(???)
  }
}